<?php
/*
Plugin Name: Kilho's Anti Backdoor for WordPress
Plugin URI: http://www.kilho.net/
Description: 위험성있는 코드가 사용된 파일 검색 플러그인
Author: Oh Kilho
Version: 0.91
Author URI: http://www.kilho.net/
*/

define('KH_SCAN_FILE', plugin_dir_path(__FILE__).'kh-scan.dat');

class KH_Scanner
{
	private function SeekFile($dir, &$files)
	{
		$hnd = opendir($dir);
		while (false !== ($entry = readdir($hnd))) 
		{
			if(in_array($entry, array('.', '..'))) continue;

			if(is_dir($dir.$entry) && !in_array($entry, array('.', '..')))
			{
				$this->SeekFile($dir.$entry.'/', $files);
			}else{
				if(!in_array(substr($entry, strrpos($entry, '.')+1), array('php', 'inc', 'html', 'htm', 'php3'))) continue;

				$file = $dir.$entry;
				if(!in_array($file, $files)) $files[] = $file;
			}
		}
		closedir($hnd);
	}

	private function Diagnosis($files)
	{
		$suspicion = array();
		$loop = 0;
		do {
			$file = $files[$loop];
			$loop++;
			
			if($file == $_SERVER['SCRIPT_FILENAME']) continue;

			$data = file_get_contents($file);
			$data = preg_replace('/\/\*(.*?)\*\//is', '', $data);
			$data = preg_replace('/\/\/*(.*)\n/', '', $data);

			if(preg_match('/(^|\s|\?php3|[?])(eval|system|exec)\s*\(/i', $data))
				$suspicion[] = $file; 
		} while ($loop < count($files));

		return $suspicion;
	}

	public function Run()
	{
		$files = array();
		$this->SeekFile($_SERVER['DOCUMENT_ROOT'].'/', $files);
		return $this->Diagnosis($files);
	}
}

function kh_scan_install()
{
	wp_schedule_event(time(), 'hourly', 'kh_scan_event');
}

function kh_scan_uninstall()
{
	unlink(KH_SCAN_FILE);

	wp_clear_scheduled_hook('kh_scan_event');
}

function kh_scan()
{
	set_time_limit(0);

	$scanner = new KH_Scanner;
	$suspicion = $scanner->Run();
	$suspicion_new = array();
	$suspicion_old = unserialize(@file_get_contents(KH_SCAN_FILE));
	file_put_contents(KH_SCAN_FILE, serialize($suspicion));

	if(!empty($suspicion))
		foreach($suspicion as $val)
			if(empty($suspicion_old)||!in_array($val, $suspicion_old))
				$suspicion_new[] = $val;

	if(!empty($suspicion_new))
	{
		switch(get_locale())
		{
			case 'ko_KR' :
				$title = "[%s] 의심파일 발견";
				$content = "위험성이 있는 코드가 사용된 파일이 발견되었습니다.\r\n\r\n%s";
				break;

			case 'ja' :
				$title = "[%s] 疑わしいファイルを発見";
				$content = "疑わしいコードを含むファイルが見つかりました。\r\n\r\n%s";
				break;
			
			default :
				$title = "[%s] Found a suspicious file";
				$content = "A file with suspicious code was detected.\r\n\r\n%s";
		}

		wp_mail(get_bloginfo('admin_email'), sprintf($title, get_bloginfo('name')), sprintf($content, implode("\r\n", $suspicion_new)));
	}
}

add_action('kh_scan_event', 'kh_scan');
add_action('activated_plugin', 'kh_scan_install');
add_action('deactivated_plugin', 'kh_scan_uninstall');
?>